<template>
  <div>
    <Navbar/>
    <b-container>
      <b-row>
        <b-col>
          <b-table
            :items="users"
            :fields="fields"
            :sort-by.sync="sortBy"
            :sort-desc.sync="sortDesc"
            sort-icon-left
            responsive="sm"
          >
            <template v-slot:cell(actions)="row">
              <b-dropdown size="sm" id="dropdown-1" text="Actions">
                <b-dropdown-item @click="make_manager(row.item.uuid)">Make Manager</b-dropdown-item>
                <b-dropdown-item @click="make_admin(row.item.uuid)">Make Admin</b-dropdown-item>
                <b-dropdown-item @click="remove_all_roles(row.item.uuid)">Remove manager</b-dropdown-item>
                <b-dropdown-item @click="remove_all_roles(row.item.uuid)">Remove all role</b-dropdown-item>
              </b-dropdown>
            </template>
          </b-table>
        </b-col>
      </b-row>

      <b-modal :id="infoModal.id"  @ok="set_as_manager" title="Select empleyee">
        <b-form-select v-model="selected_user" :options="users_to_select"></b-form-select>
      </b-modal>
    </b-container>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import Navbar from "./Navbar.vue";
export default {
  name: "AdminDashboard",
  components: {
    Navbar
  },
  computed: {
    ...mapGetters("users", {
      users: "users"
    }),
  },
   data() {
    return {
      infoModal: {
        id: "info-modal",
        title: "",
        content: ""
      },
      sortBy: "start_date",
      sortDesc: false,
      new_manager_uuid: null,
      start_date: null,
      users_to_select: [],
      end_date: null,
      selected_user: null,
      is_show_inputs: false,
      fields: [
        { key: "email", sortable: true },
        { key: "is_admin", sortable: true },
        { key: "is_manager", sortable: true },
        { key: "actions", label: "Actions" }
      ]
    };
  },
  mounted: function() {
    console.log(this.leaves);
    this.$store.commit("login/tryToLoadToken");
    this.$store.dispatch("users/getUsers");
  },
  methods: {
    set_as_manager() {
      let body={manager_uuid: this.new_manager_uuid}
      let uuid = this.selected_user
      let data = {
        uuid,
        body
      }
      this.$store.dispatch("users/updateUser", data);
    },

    make_manager(uuid) {
        var i=0;
        var users=[]
        this.new_manager_uuid = uuid
        for (i=0;i<this.users.length;i++){
          if (this.users[i].uuid == uuid) {
            continue
          }
          users.push({"value": this.users[i].uuid, "text": this.users[i].email})
        }
        this.users_to_select = users

      this.$root.$emit("bv::show::modal", this.infoModal.id);
    }
  }
};
</script>

<style>
</style>
